#!/bin/bash
#Albert Myers
#Trace Scriptor for mlsTrace

#parse time results
timeParse(){

    realraw=$(head -1 temp | tail -1)
    realraw=${realraw:5}
    userraw=$(head -2 temp | tail -1)
    userraw=${userraw:5}
    sysraw=$(head -3 temp | tail -1)
    sysraw=${sysraw:4}

    realgzip=$(head -4 temp | tail -1)
    realgzip=${realgzip:5}
    usergzip=$(head -5 temp | tail -1)
    usergzip=${usergzip:5}
    sysgzip=$(head -6 temp | tail -1)
    sysgzip=${sysgzip:4}

    realbzip2=$(head -7 temp | tail -1)
    realbzip2=${realbzip2:5}
    userbzip2=$(head -8 temp | tail -1)
    userbzip2=${userbzip2:5}
    sysbzip2=$(head -9 temp | tail -1)
    sysbzip2=${sysbzip2:4}

    echo $1,$2,"$realraw","$userraw","$sysraw","$realgzip","$usergzip","$sysgzip","$realbzip2","$userbzip2","$sysbzip2" >> mlsTraceTime.csv
    rm temp
}
#raytrace outputs app information to stderr for some reason
raytraceTimeParse(){

    realraw=$(head -2 temp | tail -1)
    realraw=${realraw:5}
    userraw=$(head -3 temp | tail -1)
    userraw=${userraw:5}
    sysraw=$(head -4 temp | tail -1)
    sysraw=${sysraw:4}

    realgzip=$(head -6 temp | tail -1)
    realgzip=${realgzip:5}
    usergzip=$(head -7 temp | tail -1)
    usergzip=${usergzip:5}
    sysgzip=$(head -8 temp | tail -1)
    sysgzip=${sysgzip:4}

    realbzip2=$(head -10 temp | tail -1)
    realbzip2=${realbzip2:5}
    userbzip2=$(head -11 temp | tail -1)
    userbzip2=${userbzip2:5}
    sysbzip2=$(head -12 temp | tail -1)
    sysbzip2=${sysbzip2:4}

    echo $1,$2,"$realraw","$userraw","$sysraw","$realgzip","$usergzip","$sysgzip","$realbzip2","$userbzip2","$sysbzip2" >> mlsTraceTime.csv
}
#get trace file size
fileSize()
{
    raw="$3"
    rawSize=$(stat -c%s "$raw")
    gzip="$4"
    gzipSize=$(stat -c%s "$gzip")
    bzip2="$5"
    bzip2Size=$(stat -c%s "$bzip2")

    echo "$1,$2,$rawSize,$gzipSize,$bzip2Size" >> mlsTraceSize.csv
}

PIN="/home/myersar/mtrace/pin-2.12-58423-gcc.4.4.7-linux/pin -t"
TOOL=/home/myersar/mtrace/pin-2.12-58423-gcc.4.4.7-linux/source/tools/ManualExamples/obj-intel64/mlsTrace.so

mkdir ./mlsTraceResults
cd ./mlsTraceResults
rm *

#run, collect run time, collect trace size
echo 'mlsTrace Time overhead in seconds' > mlsTraceTime.csv
echo 'benchmark,num threads,raw real,raw user,raw sys,gzip real,gzip user,gzip sys,bzip2 real,bzip2 user,bzip2 sys' >> mlsTraceTime.csv

echo 'mlsTrace trace size in bytes' > mlsTraceSize.csv
echo 'benchmark,num threads,raw,gzip,bzip2' >> mlsTraceSize.csv

#FFT
BENCHMARK="/opt/parsec-3.0/ext/splash2x/kernels/fft/inst/amd64-linux.gcc/bin/fft -m20"
#1 thread
time -p ($PIN $TOOL -o fft_mlsTrace_p1_raw -- $BENCHMARK -p1 > mlsTraceLog.txt) 2> fftTimeP1raw.txt
time -p ($PIN $TOOL -o fft_mlsTrace_p1_gzip -c gzip -- $BENCHMARK -p1 >> mlsTraceLog.txt) 2> fftTimeP1gzip.txt
time -p ($PIN $TOOL -o fft_mlsTrace_p1_bzip2 -c bzip2 -- $BENCHMARK -p1 >> mlsTraceLog.txt) 2> fftTimeP1bzip2.txt
fileSize "fft" "1" "fft_mlsTrace_p1_raw.bin" "fft_mlsTrace_p1_gzip.bin.gz" "fft_mlsTrace_p1_bzip2.bin.bz2"
#timeParse "fft" "1"
#4 threads
time -p ($PIN $TOOL -o fft_mlsTrace_p4_raw -- $BENCHMARK -p4 >> mlsTraceLog.txt) 2> fftTimeP4raw.txt
time -p ($PIN $TOOL -o fft_mlsTrace_p4_gzip -c gzip -- $BENCHMARK -p4 >> mlsTraceLog.txt) 2> fftTimeP4gzip.txt
time -p ($PIN $TOOL -o fft_mlsTrace_p4_bzip2 -c bzip2 -- $BENCHMARK -p4 >> mlsTraceLog.txt) 2> fftTimeP4bzip2.txt
fileSize "fft" "4" "fft_mlsTrace_p4_raw.bin" "fft_mlsTrace_p4_gzip.bin.gz" "fft_mlsTrace_p4_bzip2.bin.bz2"
#timeParse "fft" "4"
#4 threads
time -p ($PIN $TOOL -o fft_mlsTrace_p8_raw -- $BENCHMARK -p8 >> mlsTraceLog.txt) 2> fftTimeP8raw.txt
time -p ($PIN $TOOL -o fft_mlsTrace_p8_gzip -c gzip -- $BENCHMARK -p8 >> mlsTraceLog.txt) 2>fftTimeP8gzip.txt
time -p ($PIN $TOOL -o fft_mlsTrace_p8_bzip2 -c bzip2 -- $BENCHMARK -p8 >> mlsTraceLog.txt) 2> fftTimeP8bzip2.txt
fileSize "fft" "8" "fft_mlsTrace_p8_raw.bin" "fft_mlsTrace_p8_gzip.bin.gz" "fft_mlsTrace_p8_bzip2.bin.bz2"
#timeParse "fft" "8"

#Radix
BENCHMARK="/opt/parsec-3.0/ext/splash2x/kernels/radix/inst/amd64-linux.gcc/bin/radix -r4096 -n4194304 -m2147483647"
#1 thread
time -p ($PIN $TOOL -o radix_mlsTrace_p1_raw -- $BENCHMARK -p1 >> mlsTraceLog.txt) 2> radixTimeP1raw.txt
time -p ($PIN $TOOL -o radix_mlsTrace_p1_gzip -c gzip -- $BENCHMARK -p1 >> mlsTraceLog.txt) 2> radixTimeP1gzip.txt
time -p ($PIN $TOOL -o radix_mlsTrace_p1_bzip2 -c bzip2 -- $BENCHMARK -p1 >> mlsTraceLog.txt) 2> radixTimeP1bzip2.txt
fileSize "radix" "1" "radix_mlsTrace_p1_raw.bin" "radix_mlsTrace_p1_gzip.bin.gz" "radix_mlsTrace_p1_bzip2.bin.bz2"
#timeParse "radix" "1"
#4 threads
time -p ($PIN $TOOL -o radix_mlsTrace_p4_raw -- $BENCHMARK -p4 >> mlsTraceLog.txt) 2> radixTimeP4raw.txt
time -p ($PIN $TOOL -o radix_mlsTrace_p4_gzip -c gzip -- $BENCHMARK -p4 >> mlsTraceLog.txt) 2> radixTimeP4gzip.txt
time -p ($PIN $TOOL -o radix_mlsTrace_p4_bzip2 -c bzip2 -- $BENCHMARK -p4 >> mlsTraceLog.txt) 2> radixTimeP4bzip2.txt
fileSize "radix" "4" "radix_mlsTrace_p4_raw.bin" "radix_mlsTrace_p4_gzip.bin.gz" "radix_mlsTrace_p4_bzip2.bin.bz2"
#timeParse "radix" "4"
#8 threads
time -p ($PIN $TOOL -o radix_mlsTrace_p8_raw -- $BENCHMARK -p8 >> mlsTraceLog.txt) 2> radixTimeP8raw.txt
time -p ($PIN $TOOL -o radix_mlsTrace_p8_gzip -c gzip -- $BENCHMARK -p8 >> mlsTraceLog.txt) 2> radixTimeP8gzip.txt
time -p ($PIN $TOOL -o radix_mlsTrace_p8_bzip2 -c bzip2 -- $BENCHMARK -p8 >> mlsTraceLog.txt) 2>radixTimeP8bzip2.txt
fileSize "radix" "8" "radix_mlsTrace_p8_raw.bin" "radix_mlsTrace_p8_gzip.bin.gz" "radix_mlsTrace_p8_bzip2.bin.bz2"
#timeParse "radix" "8"

#Cholesky
BENCHMARK="/opt/parsec-3.0/ext/splash2x/kernels/cholesky/inst/amd64-linux.gcc/bin/cholesky" 
#1 thread
time -p ($PIN $TOOL -o cholesky_mlsTrace_p1_raw -- $BENCHMARK -p1 < /opt/parsec-3.0/ext/splash2x/kernels/cholesky/run/tk29.O >> mlsTraceLog.txt) 2> choleskyTimeP1raw.txt
time -p ($PIN $TOOL -o cholesky_mlsTrace_p1_gzip -c gzip -- $BENCHMARK -p1 < /opt/parsec-3.0/ext/splash2x/kernels/cholesky/run/tk29.O >> mlsTraceLog.txt) 2> choleskyTimeP1gzip.txt
time -p ($PIN $TOOL -o cholesky_mlsTrace_p1_bzip2 -c bzip2  -- $BENCHMARK -p1 < /opt/parsec-3.0/ext/splash2x/kernels/cholesky/run/tk29.O >> mlsTraceLog.txt) 2> choleskyTimeP1bzip2.txt
fileSize "cholesky" "1" "cholesky_mlsTrace_p1_raw.bin" "cholesky_mlsTrace_p1_gzip.bin.gz" "cholesky_mlsTrace_p1_bzip2.bin.bz2" 
#timeParse "cholesky" "1"
#4 threads
time -p ($PIN $TOOL -o cholesky_mlsTrace_p4_raw -- $BENCHMARK -p4 < /opt/parsec-3.0/ext/splash2x/kernels/cholesky/run/tk29.O >> mlsTraceLog.txt) 2> choleskyTimeP4raw.txt
time -p ($PIN $TOOL -o cholesky_mlsTrace_p4_gzip -c gzip -- $BENCHMARK -p4 < /opt/parsec-3.0/ext/splash2x/kernels/cholesky/run/tk29.O >> mlsTraceLog.txt) 2> choleskyTimeP4gzip.txt
time -p ($PIN $TOOL -o cholesky_mlsTrace_p4_bzip2 -c bzip2  -- $BENCHMARK -p4 < /opt/parsec-3.0/ext/splash2x/kernels/cholesky/run/tk29.O >> mlsTraceLog.txt) 2> choleskyTimeP4bzip2.txt
fileSize "cholesky" "4" "cholesky_mlsTrace_p4_raw.bin" "cholesky_mlsTrace_p4_gzip.bin.gz" "cholesky_mlsTrace_p4_bzip2.bin.bz2" 
#timeParse "cholesky" "4"
#8 threads
time -p ($PIN $TOOL -o cholesky_mlsTrace_p8_raw -- $BENCHMARK -p8 < /opt/parsec-3.0/ext/splash2x/kernels/cholesky/run/tk29.O >> mlsTraceLog.txt) 2> choleskyTimeP8raw.txt
time -p ($PIN $TOOL -o cholesky_mlsTrace_p8_gzip -c gzip -- $BENCHMARK -p8 < /opt/parsec-3.0/ext/splash2x/kernels/cholesky/run/tk29.O >> mlsTraceLog.txt) 2>choleskyTimeP8gzip.txt
time -p ($PIN $TOOL -o cholesky_mlsTrace_p8_bzip2 -c bzip2  -- $BENCHMARK -p8 < /opt/parsec-3.0/ext/splash2x/kernels/cholesky/run/tk29.O >> mlsTraceLog.txt) 2> choleskyTimeP8bzip2.txt
fileSize "cholesky" "8" "cholesky_mlsTrace_p8_raw.bin" "cholesky_mlsTrace_p8_gzip.bin.gz" "cholesky_mlsTrace_p8_bzip2.bin.bz2" 
#timeParse "cholesky" "8"

BENCHMARK="/opt/parsec-3.0/ext/splash2x/apps/radiosity/inst/amd64-linux.gcc/bin/radiosity -bf 1.5e-1 -batch -room"
#1 thread
time -p ($PIN $TOOL -o radiosity_mlsTrace_p1_raw -- $BENCHMARK -p 1 >> mlsTraceLog.txt) 2> radiosityTimeP1raw.txt
time -p ($PIN $TOOL -o radiosity_mlsTrace_p1_gzip -c gzip -- $BENCHMARK -p 1 >> mlsTraceLog.txt) 2> radiosityTimeP1gzip.txt
time -p ($PIN $TOOL -o radiosity_mlsTrace_p1_bzip2 -c bzip2 -- $BENCHMARK -p 1 >> mlsTraceLog.txt) 2> radiosityTimeP1bzip2.txt
fileSize "radiosity" "1" "radiosity_mlsTrace_p1_raw.bin" "radiosity_mlsTrace_p1_gzip.bin.gz" "radiosity_mlsTrace_p1_bzip2.bin.bz2"
#timeParse "radiosity" "1"
#4 threads
time -p ($PIN $TOOL -o radiosity_mlsTrace_p4_raw -- $BENCHMARK -p 4 >> mlsTraceLog.txt) 2> radiosityTimeP4raw.txt
time -p ($PIN $TOOL -o radiosity_mlsTrace_p4_gzip -c gzip -- $BENCHMARK -p 4 >> mlsTraceLog.txt) 2> radiosityTimeP4gzip.txt
time -p ($PIN $TOOL -o radiosity_mlsTrace_p4_bzip2 -c bzip2 -- $BENCHMARK -p 4 >> mlsTraceLog.txt) 2> radiosityTimeP4bzip2.txt
fileSize "radiosity" "4" "radiosity_mlsTrace_p4_raw.bin" "radiosity_mlsTrace_p4_gzip.bin.gz" "radiosity_mlsTrace_p4_bzip2.bin.bz2"
#timeParse "radiosity" "4"
#8 threads
time -p ($PIN $TOOL -o radiosity_mlsTrace_p8_raw -- $BENCHMARK -p 8 >> mlsTraceLog.txt) 2> radiosityTimeP8raw.txt
time -p ($PIN $TOOL -o radiosity_mlsTrace_p8_gzip -c gzip -- $BENCHMARK -p 8 >> mlsTraceLog.txt) 2> radiosityTimeP8gzip.txt
time -p ($PIN $TOOL -o radiosity_mlsTrace_p8_bzip2 -c bzip2 -- $BENCHMARK -p 8 >> mlsTraceLog.txt) 2> radiosityTimeP8bzip2.txt
fileSize "radiosity" "8" "radiosity_mlsTrace_p8_raw.bin" "radiosity_mlsTrace_p8_gzip.bin.gz" "radiosity_mlsTrace_p8_bzip2.bin.bz2"
#timeParse "radiosity" "8"

#raytrace
cp /opt/parsec-3.0/ext/splash2x/apps/raytrace/run/teapot.env ./
cp /opt/parsec-3.0/ext/splash2x/apps/raytrace/run/teapot.geo ./
cp /opt/parsec-3.0/ext/splash2x/apps/raytrace/run/teapot.rl ./
BENCHMARK="/opt/parsec-3.0/ext/splash2x/apps/raytrace/inst/amd64-linux.gcc/bin/raytrace -s -a8"
#1 thread
time -p ($PIN $TOOL -o raytrace_mlsTrace_p1_raw -- $BENCHMARK -p1 teapot.env >> mlsTraceLog.txt) 2> raytraceTimeP1raw.txt
time -p ($PIN $TOOL -o raytrace_mlsTrace_p1_gzip -c gzip -- $BENCHMARK -p1 teapot.env >> mlsTraceLog.txt) 2> raytraceTimeP1gzip.txt
time -p ($PIN $TOOL -o raytrace_mlsTrace_p1_bzip2 -c bzip2 -- $BENCHMARK -p1 teapot.env >> mlsTraceLog.txt) 2> raytraceTimeP1bzip2.txt
fileSize "raytrace" "1" "raytrace_mlsTrace_p1_raw.bin" "raytrace_mlsTrace_p1_gzip.bin.gz" "raytrace_mlsTrace_p1_bzip2.bin.bz2"
#raytraceTimeParse "raytrace" "1"
#4 thread
time -p ($PIN $TOOL -o raytrace_mlsTrace_p4_raw -- $BENCHMARK -p4 teapot.env >> mlsTraceLog.txt) 2> raytraceTimeP4raw.txt
time -p ($PIN $TOOL -o raytrace_mlsTrace_p4_gzip -c gzip -- $BENCHMARK -p4 teapot.env >> mlsTraceLog.txt) 2> rayTraceP4gzip.txt
time -p ($PIN $TOOL -o raytrace_mlsTrace_p4_bzip2 -c bzip2 -- $BENCHMARK -p4 teapot.env >> mlsTraceLog.txt) 2> rayTraceP4bzip2.txt
fileSize "raytrace" "4" "raytrace_mlsTrace_p4_raw.bin" "raytrace_mlsTrace_p4_gzip.bin.gz" "raytrace_mlsTrace_p4_bzip2.bin.bz2"
#raytraceTimeParse "raytrace" "4"
#8 thread
time -p ($PIN $TOOL -o raytrace_mlsTrace_p8_raw -- $BENCHMARK -p8 teapot.env >> mlsTraceLog.txt) 2> raytraceTimeP8raw.txt
time -p ($PIN $TOOL -o raytrace_mlsTrace_p8_gzip -c gzip -- $BENCHMARK -p8 teapot.env >> mlsTraceLog.txt) 2> raytraceTimeP8gzip.txt
time -p ($PIN $TOOL -o raytrace_mlsTrace_p8_bzip2 -c bzip2 -- $BENCHMARK -p8 teapot.env >> mlsTraceLog.txt) 2> raytraceTimeP8bzip2.txt
fileSize "raytrace" "8" "raytrace_mlsTrace_p8_raw.bin" "raytrace_mlsTrace_p8_gzip.bin.gz" "raytrace_mlsTrace_p8_bzip2.bin.bz2"
#raytraceTimeParse "raytrace" "8"


#Rerun with instrumentation for store instructions
#FFT
BENCHMARK="/opt/parsec-3.0/ext/splash2x/kernels/fft/inst/amd64-linux.gcc/bin/fft -m20"
$PIN $TOOL -o fft_mlsTrace_p1_store_raw -store -- $BENCHMARK -p1 > mlsTraceStoreLog.txt
$PIN $TOOL -o fft_mlsTrace_p4_store_raw -store -- $BENCHMARK -p4 >> mlsTraceStoreLog.txt
$PIN $TOOL -o fft_mlsTrace_p8_store_raw -store -- $BENCHMARK -p8 >> mlsTraceStoreLog.txt
#Radix
BENCHMARK="/opt/parsec-3.0/ext/splash2x/kernels/radix/inst/amd64-linux.gcc/bin/radix -r4096 -n4194304 -m2147483647"
$PIN $TOOL -o radix_mlsTrace_p1_store_raw -store -- $BENCHMARK -p1 >> mlsTraceStoreLog.txt 
$PIN $TOOL -o radix_mlsTrace_p4_store_raw -store -- $BENCHMARK -p4 >> mlsTraceStoreLog.txt 
$PIN $TOOL -o radix_mlsTrace_p8_store_raw -store -- $BENCHMARK -p8 >> mlsTraceStoreLog.txt
#Cholesky
BENCHMARK="/opt/parsec-3.0/ext/splash2x/kernels/cholesky/inst/amd64-linux.gcc/bin/cholesky" 
$PIN $TOOL -o cholesky_mlsTrace_p1_store_raw -store -- $BENCHMARK -p1 < /opt/parsec-3.0/ext/splash2x/kernels/cholesky/run/tk29.O >> mlsTraceStoreLog.txt
$PIN $TOOL -o cholesky_mlsTrace_p4_store_raw -store -- $BENCHMARK -p4 < /opt/parsec-3.0/ext/splash2x/kernels/cholesky/run/tk29.O >> mlsTraceStoreLog.txt
$PIN $TOOL -o cholesky_mlsTrace_p8_store_raw -store -- $BENCHMARK -p8 < /opt/parsec-3.0/ext/splash2x/kernels/cholesky/run/tk29.O >> mlsTraceStoreLog.txt
BENCHMARK="/opt/parsec-3.0/ext/splash2x/apps/radiosity/inst/amd64-linux.gcc/bin/radiosity -bf 1.5e-1 -batch -room"
$PIN $TOOL -o radiosity_mlsTrace_p1_store_raw -store -- $BENCHMARK -p 1 >> mlsTraceStoreLog.txt
$PIN $TOOL -o radiosity_mlsTrace_p4_store_raw -store -- $BENCHMARK -p 4 >> mlsTraceStoreLog.txt
$PIN $TOOL -o radiosity_mlsTrace_p8_store_raw -store -- $BENCHMARK -p 8 >> mlsTraceStoreLog.txt
BENCHMARK="/opt/parsec-3.0/ext/splash2x/apps/raytrace/inst/amd64-linux.gcc/bin/raytrace -s -a8"
$PIN $TOOL -o raytrace_mlsTrace_p1_store_raw -store -- $BENCHMARK -p1 teapot.env >> mlsTraceStoreLog.txt
$PIN $TOOL -o raytrace_mlsTrace_p4_store_raw -store -- $BENCHMARK -p4 teapot.env >> mlsTraceStoreLog.txt
$PIN $TOOL -o raytrace_mlsTrace_p8_store_raw -store -- $BENCHMARK -p8 teapot.env >> mlsTraceStoreLog.txt

echo 'mlsTrace Benchmark Characterization' > mlsTraceBenchmarkCharacterization.csv
echo 'benchmark name, num threads, instruction count, load instructions, load bytes, load words, load dword, load quadword, load extended prec, load octawords, load hexa words, load other, store instructions, store bytes, store words, store dword, store quadword, store extended prec, store octawords, store hexa words, store other ' >> mlsTraceBenchmarkCharacterization.csv

echo -n 'fft,' >> mlsTraceBenchmarkCharacterization.csv
head -23 fft_mlsTrace_p1_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv
echo -n 'fft,' >> mlsTraceBenchmarkCharacterization.csv
head -23 fft_mlsTrace_p4_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv
echo -n 'fft,' >> mlsTraceBenchmarkCharacterization.csv
head -23 fft_mlsTrace_p8_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv

echo -n 'radix,' >> mlsTraceBenchmarkCharacterization.csv
head -23 radix_mlsTrace_p1_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv
echo -n 'radix,' >> mlsTraceBenchmarkCharacterization.csv
head -23 radix_mlsTrace_p4_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv
echo -n 'radix,' >> mlsTraceBenchmarkCharacterization.csv
head -23 radix_mlsTrace_p8_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv

echo -n 'cholesky,'  >> mlsTraceBenchmarkCharacterization.csv
head -23 cholesky_mlsTrace_p1_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv
echo -n 'cholesky,'  >> mlsTraceBenchmarkCharacterization.csv
head -23 cholesky_mlsTrace_p4_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv
echo -n 'cholesky,'  >> mlsTraceBenchmarkCharacterization.csv
head -23 cholesky_mlsTrace_p8_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv

echo -n 'radiosity,' >> mlsTraceBenchmarkCharacterization.csv
head -23 radiosity_mlsTrace_p1_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv
echo -n 'radiosity,' >> mlsTraceBenchmarkCharacterization.csv
head -23 radiosity_mlsTrace_p4_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv
echo -n 'radiosity,' >> mlsTraceBenchmarkCharacterization.csv
head -23 radiosity_mlsTrace_p8_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv

echo -n 'raytrace,' >> mlsTraceBenchmarkCharacterization.csv
head -23 raytrace_mlsTrace_p1_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv
echo -n 'raytrace,' >> mlsTraceBenchmarkCharacterization.csv
head -23 raytrace_mlsTrace_p4_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv
echo -n 'raytrace,' >> mlsTraceBenchmarkCharacterization.csv
head -23 raytrace_mlsTrace_p8_store_raw.Statistics | tail -1 >> mlsTraceBenchmarkCharacterization.csv


